-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.relevantDevice = nil 


local fl = 0
local abr = 0
local throttle = 0

local min = math.min
local max = math.max

local function onReset()
    fl = 0
    abr = 0
    electrics.values.flaps = fl
    electrics.values.airbrake = abr
    electrics.values.throttleup = 0
    electrics.values.throttledown = 0
    electrics.values.throttlemtngoat = 0
end


local function flap(VALUE)
    if VALUE == 1 then
        fl = 1 - fl
        electrics.values.flaps = fl
    end
end

local function abrake(VALUE)
    if VALUE == 1 then
        abr = 1 - abr
        electrics.values.airbrake = abr
    end
end



local function updateGFX(dt)
    local throttle = electrics.values.throttlemtngoat or 0

    throttle = min(max(throttle + (electrics.values.throttleup * dt * 0.5) - (electrics.values.throttledown * dt * 0.5), 0), 1)
    electrics.values.throttle = throttle

    electrics.values.throttlemtngoat = throttle


end


M.onInit    = onReset
M.onReset   = onReset
M.flap      = flap
M.abrake    = abrake
M.updateGFX = updateGFX


return M